diff --git a/books/bookvol10.4.pamphlet b/books/bookvol10.4.pamphlet
index 4f39b17..a43be66 100644
--- a/books/bookvol10.4.pamphlet
+++ b/books/bookvol10.4.pamphlet
@@ -60773,9 +60773,11 @@ MultFiniteFactorize(OV,E,F,PG) : C == T
             [lfg.contp,append(factorlist,lfg.factors)]
 
 
-        om:=map(pushup(#1,basicVar),um)$UPCF2(P,SUP P,PG,SUP PG)
+        om:=map((p1:P):PG+->pushup(p1,basicVar),um)$UPCF2(P,SUP P,PG,SUP PG)
         sqfacs:=squareFree(om)
-        lcont:=map(pushdown(#1,basicVar),unit sqfacs)$UPCF2(PG,SUP PG,P,SUP P)
+        lcont:=
+          map((p1:PG):P+->pushdown(p1,basicVar),unit sqfacs)_
+            $UPCF2(PG,SUP PG,P,SUP P)
 
                                    ----   Factorize the content  ----
         if ground? lcont then
@@ -60786,7 +60788,7 @@ MultFiniteFactorize(OV,E,F,PG) : C == T
         factorlist:=flead.factors
 
                                  ----  Make the polynomial square-free  ----
-        sqqfact:=[[map(pushdown(#1,basicVar),ff.factor),ff.exponent]
+        sqqfact:=[[map((p:PG):P+->pushdown(p,basicVar),ff.factor),ff.exponent]
                       for ff in factors sqfacs]
 
                         ---  Factorize the primitive square-free terms ---
@@ -60801,7 +60803,8 @@ MultFiniteFactorize(OV,E,F,PG) : C == T
           else lf:=mfpol(ffactor,dx,lvar,ldeg)
           auxfl:=[[lfp,ffexp]$SUParFact  for lfp in lf]
           factorlist:=append(factorlist,auxfl)
-        lcfacs := */[leadingCoefficient leadingCoefficient(f.irr)**((f.pow)::NNI)
+        lcfacs := 
+           */[leadingCoefficient leadingCoefficient(f.irr)**((f.pow)::NNI)
                              for f in factorlist]
         [(leadingCoefficient leadingCoefficient(um) exquo lcfacs)::R,
                        factorlist]$SUPFinalFact
@@ -60811,14 +60814,13 @@ MultFiniteFactorize(OV,E,F,PG) : C == T
         ld:=degree(um,lv)
         dx:="min"/ld
         basicVar:=lv.position(dx,ld)
-        cm:=map(pushdown(#1,basicVar),um)$UPCF2(PG,SUP PG,P,SUP P)
+        cm:=map((p1:PG):P+->pushdown(p1,basicVar),um)$UPCF2(PG,SUP PG,P,SUP P)
         flist := supFactor(cm,dx)
         pushupconst(flist.contp,basicVar)::SUP(PG) *
-          (*/[primeFactor(map(pushup(#1,basicVar),u.irr)$UPCF2(P,SUP P,PG,SUP PG),
+         (*/[primeFactor(
+           map((p1:P):PG+->pushup(p1,basicVar),u.irr)$UPCF2(P,SUP P,PG,SUP PG),
                  u.pow) for u in flist.factors])
 
-
-
     mFactor(m:P,dx:Z) : MFinalFact ==
       ground?(m) => constantCase(m,empty())
       lvar:L OV:= variables m
@@ -60910,7 +60912,7 @@ MultFiniteFactorize(OV,E,F,PG) : C == T
 
       ----  push x in the coefficient domain for a term ----
     pushdcoef(t:PG):P ==
-       map(coerce(#1)$R,t)$MPolyCatFunctions2(OV,E,
+       map((f1:F):R+->coerce(f1)$R,t)$MPolyCatFunctions2(OV,E,
                                            IndexedExponents OV,F,R,PG,P)
 
 
diff --git a/changelog b/changelog
index 49a6f6e..402e7a3 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,5 @@
+20090608 tpd src/axiom-website/patches.html 20090608.07.tpd.patch
+20090608 tpd books/bookvol10.4 MFINFACT +-> conversion
 20090608 tpd src/axiom-website/patches.html 20090608.06.tpd.patch
 20090608 tpd books/bookvol10.4 MPRFF +-> conversion
 20090608 tpd src/axiom-website/patches.html 20090608.05.tpd.patch
diff --git a/src/axiom-website/patches.html b/src/axiom-website/patches.html
index 291ff78..1da4ee9 100644
--- a/src/axiom-website/patches.html
+++ b/src/axiom-website/patches.html
@@ -1507,5 +1507,7 @@ bookvol10.4 MDDFACT +-> conversion<br/>
 bookvol10.4 MHROWRED +-> conversion<br/>
 <a href="patches/20090608.06.tpd.patch">20090608.06.tpd.patch</a>
 bookvol10.4 MPRFF +-> conversion<br/>
+<a href="patches/20090608.06.tpd.patch">20090608.07.tpd.patch</a>
+bookvol10.4 MFINFACT +-> conversion<br/>
  </body>
 </html>
